/**
* A collection of error handling methods for ProjectAES
*
* This program is made freely available under the liberal MIT license. 
*  Please see the accompanying file, License.txt, for full details.
**/

#define MAX_STRING_LEN 128

typedef enum {
    UNKOWN_PARAMETER,
    MISSING_PARAMETER,
    FILE_OPEN_ERROR,
    FILE_READ_ERROR,
    FILE_WRITE_ERROR,
    UNKOWN_FILE_TYPE,
    KEY_TOO_SHORT
} ERRORS;

/**
*
**/
void fatalError(int errCode, char* param1, char* param2){
    printf("Error: ");
    switch(errCode){
        case UNKOWN_PARAMETER:
            printf("unkown parameter, \"%s\".\n", param1);
            printf("Please see program usage by typing \"%s --help\"", param2);
            break;
        case MISSING_PARAMETER:
            printf("missing a required argument.\n");
            printf("Please see program usage by typing \"%s --help\"", param1);
            break;
        case FILE_OPEN_ERROR:
            printf("could not open the file, \"%s\".\n", param1);
            printf("Please check the filename and try again.");
            break;
        case FILE_READ_ERROR:
            printf("problem reading the file, \"%s\".\n", param1);
            break;
        case FILE_WRITE_ERROR:
            printf("problem writting to the file, \"%s\".\n", param1);
            break;
        case UNKOWN_FILE_TYPE:
            printf("unkown file type.");
            break;
        case KEY_TOO_SHORT:
            printf("key is not long enough. Minimum length is %d characters.", 4*Nk);
            break;
    }
    printf("\n");
    exit(1);
}
